\documentclass[a4paper, hole]{./tpl/ddpoly-en}
\usepackage{dirtree}
\usepackage{wasysym}
\usepackage{mathtools}
\usepackage{enumitem}
\setlist{nolistsep}

\input{macro}
\input{tpl/listing-config}

\graphicspath{{tpl/}{img/}}
\ddmodulename{Computer Science}
\ddmodulenumber{Tuto minidem}
\ddauthor{D. André}
\dduniv{Ensil-Ensci}
\ddimg{\begin{center}\includegraphics[width=6cm]{img/arduino-logo}\end{center}}
\rien

\begin{document}
\renewcommand{\labelitemi}{$\bullet$}
\lstset{language=granCpp,style=granCpp}  
\lstset{language=granPython,style=granPython}  

\newdemexo{03}{Reflections on Rigid Walls}

\noindent The objective of this tutorial is to familiarize yourself with collision management on rigid walls. Rather than collision, it is more accurate to speak of \textbf{reflection} here. In this script, these reflections are implemented in the function \texttt{rigid\_wall()}. For each rigid wall, this function:
\begin{enumerate}
\item tests if the grain is in contact with this wall,
\item if true, the position of the grain is corrected to avoid interpenetration,
\item and then the velocity is corrected to achieve a reflection.
\end{enumerate}
Additionally, this exercise shows how to assign a color to a grain. The list of possible colors is available in the \href{https://matplotlib.org/stable/gallery/color/named_colors.html}{Matplotlib documentation}.

\vspace{0.5cm}

\begin{task}
  Download the module \dldem{minidem.py} and the script
  \dltutodem{03}{tuto-03\_exercice.py}. Run the script
  \dltutodem{03}{tuto-03\_exercice.py}.
\end{task}

\begin{info}
At this stage, you should obtain a simulation similar to the video \dltutodem{03}{tuto-03\_exercice.mp4}.
\end{info}

\begin{task}
  Observe and try to understand the function \texttt{rigid\_wall()}.
\end{task}

\begin{task}
  Modify the function \texttt{rigid\_wall()} to change the color of the grains when they collide with one of the walls.
\end{task}

\begin{task}
  Modify the function \texttt{rigid\_wall()} to set the velocities of the grains to zero when they collide with one of the walls. The grains should then stick to the walls!
\end{task}

\begin{info}
  At this stage, you should obtain a simulation similar to the video \dltutodem{03}{tuto-03\_correction.mp4}.
\end{info}

\end{document}